﻿using System.Windows;
using System.Windows.Controls;
using System.Threading;
using Infragistics.Olap;
using Infragistics.Olap.Data;
using System.ComponentModel;

namespace FilterMemberExpansionXMLA
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs eventArgs)
        {
            BackgroundWorker worker = new BackgroundWorker();
            worker.DoWork += (s, e) =>
            {
                var dataSource = e.Argument as DataSourceBase;
                for (int i = 0; i < dataSource.Rows.Count; i++)
                {
                    IFilterViewModel fvm = dataSource.Rows[i] as IFilterViewModel;
                    if (fvm != null && fvm.FilterMembers != null)
                    {
                        foreach (IFilterMember member in fvm.FilterMembers)
                        {
                            DrillIn(fvm, member);
                        }
                    }
                }
                for (int i = 0; i < dataSource.Columns.Count; i++)
                {
                    IFilterViewModel fvm = dataSource.Columns[i] as IFilterViewModel;
                    if (fvm != null && fvm.FilterMembers != null)
                    {
                        foreach (IFilterMember member in fvm.FilterMembers)
                        {
                            DrillIn(fvm, member);
                        }
                    }
                }
            };
            worker.RunWorkerCompleted += (s, e) => this.xamPivotGrid.DataSource.RefreshGrid(); ;
            worker.RunWorkerAsync(this.xamPivotGrid.DataSource);
        }

        private void DrillIn(IFilterViewModel filterViewModel, IFilterMember filterMember)
        {
            ManualResetEvent manualResetEvent = new ManualResetEvent(false);
            filterViewModel.LoadFilterMembersCompleted += (sender, e) =>
            {
                manualResetEvent.Set();
            };

            if (filterMember.IsExpanded == false)
            {
                if (filterMember.Member.LevelDepth > 1) //or whatever stop condition you want 
                    return;

                filterMember.IsExpanded = true;
                manualResetEvent.WaitOne();
            }

            foreach (IFilterMember member in filterMember.FilterMembers)
            {
                DrillIn(filterViewModel, member);
            }
        }
    }
}
